public class FloorTile
{
  PVector force = new PVector();
  PVector touchPoint = new PVector(-1, -1);
  PVector init = new PVector();

  PVector size = new PVector();
  PVector position = new PVector();

  int num;
  float weight;
  float sensor1, sensor2, sensor3, sensor4;
  float oldSensor1, oldSensor2, oldSensor3, oldSensor4;

  public FloorTile(int _num, PVector _size, PVector _position)
  {
    size = _size;
    position = _position;
    num = _num;
  }

  void initialize(OscMessage _sensorValues)
  {
    sensor1 = _sensorValues.get(4).floatValue();
    sensor2 = _sensorValues.get(1).floatValue();
    sensor3 = _sensorValues.get(2).floatValue();
    sensor4 = _sensorValues.get(3).floatValue();

    weight = abs((sensor1+sensor2+sensor3+sensor4));

    init.x += map((sensor3+sensor4)-(sensor1+sensor2), 0, weight, 0, size.y);
    init.y += map((sensor2+sensor3)-(sensor1+sensor4), 0, weight, 0, size.x);
    init.z += 1;
  }

  void update(OscMessage _sensorValues)
  {    
    sensor1 = (0.9*oldSensor1)+(0.1*_sensorValues.get(4).floatValue());
    sensor2 = (0.9*oldSensor2)+(0.1*_sensorValues.get(1).floatValue());
    sensor3 = (0.9*oldSensor3)+(0.1*_sensorValues.get(2).floatValue());
    sensor4 = (0.9*oldSensor4)+(0.1*_sensorValues.get(3).floatValue());

    weight = abs((sensor1+sensor2+sensor3+sensor4));

    if (weight>20)
    {
      force.x = map((sensor3+sensor4)-(sensor1+sensor2), 0, weight, 0, size.y)+size.y/2-init.x;
      force.y = map((sensor2+sensor3)-(sensor1+sensor4), 0, weight, 0, size.x)+size.x/2-init.y;

      force.x = constrain(force.x, 0, size.x);
      force.y = constrain(force.y, 0, size.y);

      touchPoint.x = force.x+position.x;
      touchPoint.y = force.y+position.y;
    }
    else
    {
      touchPoint.x = -1;
      touchPoint.y = -1;
    }
  }

  void draw()
  {
    noFill();
    stroke(255, 50);
    rect(position.x, position.y, size.x, size.y);

    drawCursor(touchPoint, 5);
  } 

  void drawCursor(PVector _position, int _size)
  {
    stroke(255, 0, 0);
    line(_position.x, _position.y-_size, _position.x, _position.y+_size);
    line(_position.x-_size, _position.y, _position.x+_size, _position.y);
  }
  
  PVector getMidPoint()
  {
    PVector _midPoint = new PVector();
    
    _midPoint.x = position.x+size.x/2;
    _midPoint.y = position.y+size.y/2; 
    
    return _midPoint;
  }
}

